/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.CategoriaTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.service.CategoriaTipoPtoVtaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.CustomEnum;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCategoriaTipoPtoVta;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoPuntoVentaController")
@Scope("prototype")
public class EditarTipoPuntoVentaController extends MyGenericForwardComposer {

    @Autowired
    private TipoPuntoVentaService tipoPuntoVentaService;
    @Autowired
    private CategoriaTipoPtoVtaService categoriaTipoPtoVtaService;
    @Autowired
    private CategoriaService categoriaService;
    private List<CategoriaTipoPtoVta> lsCategoriaTipoPtoVta;
    private List<Categoria> lsCategoria;
    private MyListbox categoriaTipoPtoVtaList;
    private TipoPuntoVenta tipoPuntoVenta;
    private MyListbox tipoPuntoVentaList;
    private MyTextbox txtNome;
    private static Logger log = LogManager.getLogger(EditarFormaPagoController.class);
    private Button btnApagar;
    private Row rowEquivalencia;
    private Combobox cmbCategoria;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoPuntoVenta getTipoPuntoVenta() {
        return tipoPuntoVenta;
    }

    public void setTipoPuntoVenta(TipoPuntoVenta tipoPuntoVenta) {
        this.tipoPuntoVenta = tipoPuntoVenta;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    public List<Categoria> getLsCategoria() {
        return lsCategoria;
    }

    public void setLsCategoria(List<Categoria> lsCategoria) {
        this.lsCategoria = lsCategoria;
    }

    public List<CategoriaTipoPtoVta> getLsCategoriaTipoPtoVta() {
        return lsCategoriaTipoPtoVta;
    }

    public void setLsCategoriaTipoPtoVta(List<CategoriaTipoPtoVta> lsCategoriaTipoPtoVta) {
        this.lsCategoriaTipoPtoVta = lsCategoriaTipoPtoVta;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsCategoria = categoriaService.obtenerTodos();

        super.doAfterCompose(comp);

        tipoPuntoVenta = (TipoPuntoVenta) Executions.getCurrent().getArg().get("tipoPuntoVenta");
        tipoPuntoVentaList = (MyListbox) Executions.getCurrent().getArg().get("tipoPuntoVentaList");

        categoriaTipoPtoVtaList.setItemRenderer(new RenderCategoriaTipoPtoVta());
        lsCategoriaTipoPtoVta = new ArrayList<CategoriaTipoPtoVta>();
        categoriaTipoPtoVtaList.setData(lsCategoriaTipoPtoVta);

        if (tipoPuntoVenta.getTipoptovtaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            lsCategoriaTipoPtoVta = categoriaTipoPtoVtaService.buscarPorPuntoVenta(tipoPuntoVenta);
            categoriaTipoPtoVtaList.setData(lsCategoriaTipoPtoVta);
        }

        if (!ApplicationProperties.getInstance().isCustomHabilitado(CustomEnum.MOSTRAR_EQUIVALENCIA.getDescricao())) {
            rowEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getText();

        try {

            tipoPuntoVenta.setActivo(Boolean.TRUE);
            tipoPuntoVenta.setFecmodif(Calendar.getInstance().getTime());
            tipoPuntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            tipoPuntoVenta.setLsCategoriaTipoPtoVta(lsCategoriaTipoPtoVta);

            List<TipoPuntoVenta> lsTipoPunto = tipoPuntoVentaService.buscar(tipoPuntoVenta.getDesctipo());

            if (!lsTipoPunto.isEmpty() && tipoPuntoVenta.getTipoptovtaId() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoPuntoVenta.getTipoptovtaId() == null) {
                    tipoPuntoVentaService.suscribir(tipoPuntoVenta);
                    tipoPuntoVentaList.addItem(tipoPuntoVenta);
                } else {
                    tipoPuntoVentaService.actualizacion(tipoPuntoVenta);
                    tipoPuntoVentaList.updateItem(tipoPuntoVenta);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoPuntoVentaController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error("editarTipoPuntoVentaController :" + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoPuntoVentaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                tipoPuntoVentaService.borrar(tipoPuntoVenta);

                Messagebox.show(
                        Labels.getLabel("editarTipoPuntoVentaController.MSG.borrarOK"),
                        Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoPuntoVentaList.removeItem(tipoPuntoVenta);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnAdicionarCategoriaTipoPtoVta(Event ev) throws InterruptedException {
        cmbCategoria.getValue();

        try {
            Categoria cat = (Categoria) cmbCategoria.getSelectedItem().getValue();
            Boolean achou = Boolean.FALSE;
            for (CategoriaTipoPtoVta cds : lsCategoriaTipoPtoVta) {
                if (cds.getCategoria() == cat) {
                    achou = Boolean.TRUE;
                }
            }

            if (!achou) {
                CategoriaTipoPtoVta cd = new CategoriaTipoPtoVta();
                cd.setActivo(Boolean.TRUE);
                cd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                cd.setFecmodif(Calendar.getInstance().getTime());
                cd.setCategoria(cat);
                cd.setTipoPuntoVenta(tipoPuntoVenta);

                lsCategoriaTipoPtoVta.add(cd);
                List<CategoriaTipoPtoVta> lsAux = new ArrayList<CategoriaTipoPtoVta>();

                for (CategoriaTipoPtoVta c : lsCategoriaTipoPtoVta) {
                    if (c.getActivo()) {
                        lsAux.add(c);
                    }
                }
                categoriaTipoPtoVtaList.setData(lsAux);

            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }

        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoPuntoVentaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnRemoverCategoriaTipoPtoVta(Event ev) {
        CategoriaTipoPtoVta cd = (CategoriaTipoPtoVta) categoriaTipoPtoVtaList.getSelected();

        if (cd != null) {

            cd.setActivo(Boolean.FALSE);
            cd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            cd.setFecmodif(Calendar.getInstance().getTime());
            cd.setTipoPuntoVenta(tipoPuntoVenta);

            if (cd.getCategoriatipoptovtaId() != null) {
                categoriaTipoPtoVtaService.borrarFisico(cd);
            }

            lsCategoriaTipoPtoVta.remove(cd);
            categoriaTipoPtoVtaList.setData(lsCategoriaTipoPtoVta);
        }
    }
}
